

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>


enum {
	// _xinfreq = 20_000_000,
	_xtlfreq = 20_000_000,
	_clkfreq = 4_000_000,
	DOWNLOAD_BAUD = 230_400,
	DEBUG_BAUD = DOWNLOAD_BAUD,

};


static uint8_t  data_hex[] = {1,2,3,4,5,6,7,8,9,10,
	11,12,13,14,15,16,17,18,19,20,
	21,22,23,24,25,26,27,28,29,30,
	31,32,33,34,35,36,37,38,39,40,41,42};


static uint32_t rdfast_test( uint32_t ticks, uint32_t addr )
{
	__asm volatile { // no optimising and enforces Fcache use - Needed to free up the FIFO
		waitx	ticks
		getct	ticks
		rdfast	nonblk, #64
		wrbyte	ticks, addr
		getct	pb
		subr	ticks, pb
		waitx	#500
		ret

nonblk	long	$8000_0000
	}
	return ticks;
}


void  main( void )
{
	uint32_t  i, j;

	_waitms( 200 );
	printf( "\n   clkfreq = %d   clkmode = 0x%x\n", _clockfreq(), _clockmode() );

	printf( "\n       0   1   2   3   4   5   6   7   8   9\n     ========================================" );
	for( j = 0; j < 64; j += 4 )
	{
		printf( "\n %2d: ", j );
		for( i = 0; i < 10; i++ )
			printf( " %2d ", rdfast_test( i, j ) );
	}
	printf( "\n" );

}
